<template>
    <app-layout :user="user">
        <div class="row justify-content-between">
            <div class="col">
                <h1 class="h2 mb-3">Leaderboard</h1>
            </div>
            <div class="col-lg-6 col-sm-7">
                <form @submit.prevent="form.get(route('leaderboard'))">
                    <form-field id="inputSearch" :errors="form.errors.search" v-slot="slotProps">
                        <form-input v-model="form.search" v-bind="slotProps" placeholder="Name or GUID" />
                        <form-button :disabled="form.processing">Search</form-button>
                        <inertia-link v-if="user" as="button" type="button" class="btn btn-danger" method="delete" :href="route('leaderboard.clear')">Clear Leaderboard</inertia-link>
                    </form-field>
                </form>
            </div>
        </div>
        
        <table class="table table-hover">
            <thead>
                <tr class="table-dark">
                    <th v-for="(text, field, index) in fields" :key="index" scope="col">
                        <inertia-link class="text-decoration-none text-white d-block" :href="route('leaderboard')" :data="getSortData(field)">
                            {{ text }}
                            <span v-if="sort === field" class="ms-1">
                                <span v-if="dir === 'asc'">▲</span>
                                <span v-else>▼</span>
                            </span>
                        </inertia-link>
                    </th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="player in players.data" :key="player.id">
                    <td v-for="(text, field, index) in fields" :key="index">
                        <inertia-link v-if="user && field === 'id'" :href="route('players.get', player)" class="text-decoration-none d-block">
                            {{ formatField(field, player[field]) }}
                        </inertia-link>
                        <template v-else>{{ formatField(field, player[field]) }}</template>
                    </td>
                </tr>
            </tbody>
        </table>
        
        <pagination :links="players.links" />
    </app-layout>
</template>

<script>
    import { useForm } from '@inertiajs/inertia-vue3'
    import AppLayout from '@/Layouts/AppLayout'
    import Pagination from '@/Components/Pagination'
    import FormInput from '@/Components/Form/FormInput'
    import FormField from '@/Components/Form/FormField'
    import FormButton from '@/Components/Form/FormButton'
    
    export default {
        props: {
            'players': Object,
            'fields': Object,
            'search': String,
            'sort': String,
            'dir': String,
            'user': Object,
        },
        
        components: {
            AppLayout,
            Pagination,
            FormInput,
            FormField,
            FormButton,
        },
        
        setup () {
            const form = useForm({
                search: null,
            })

            return { form }
        },
        
        mounted() {
            this.form.search = this.search
        },
        
        methods: {
            getSortData(field) {
                let data = {
                    'sort': field 
                }
                
                if (this.sort == field) {
                    data['dir'] = this.dir === 'asc' ? 'desc' : 'asc'
                } else {
                    data['dir'] = 'desc'
                }
                
                if (this.search !== null) {
                    data['search'] = this.search
                }
                
                return data
            },
            
            formatField(field, value) {
                if (field === 'updated_at') {
                    return (new Date(value)).toLocaleString('en-GB')
                } else {
                    return value
                }
            },
        }
    }
</script>